function [valout,flag,relres,iter] = taylorR1Lnfft_lsqr_solve(x,rhs,freq,m,z,M,tol,nit)
  if nargin < 7
    tol = 1e-5;
  end
  if nargin < 8
    nit = 1000;
  end
  %[valout,flag,relres,iter] = pcg(@(param) A_star_A(x,param,freq,m,z,M), rhs, tol, nit);
  %[valout,flag,relres,iter] = lsqr(@(param,flag) A_star_A(x,param,freq,m,z,M), rhs, tol, nit);
  
  
  d = length(z);
  s_array = coord_l1ball(m, d, 1);
  s_array = s_array(min(s_array,[],2) >= 0,:);
  jz = repmat((0:M-1)',1,length(z)).*repmat(z,M,1);
  jzM = mod(jz,M)/M;
  diff = x - jzM + 0.5;
  diff = diff-floor(diff) - 0.5;
  [valout,flag,relres,iter] = lsqr(@(param,flag) A_times(x,param,freq,z,M,s_array,diff,flag), rhs, tol, nit);
  fprintf('relres = %.3e, niter = %d\n', relres, iter);
  
  if ((flag ~= 0) && (flag ~= 3) && (flag ~= 1))
    error('pcg returned flag: %d', flag);
  end
  if flag == 3
    disp('lsqr stagnated');
  end
  if flag == 3
    disp('lsqr reached max niter');
  end
end

function valout = A_times(x,param,freq,z,M,s_array,diff,transp_flag)
  lx = size(x,1);
  if strcmp(transp_flag,'transp')
    valout = zeros(size(freq,1),1);
  for is=1:size(s_array,1)
    s = s_array(is,:);
    dvec_s = prod((2*pi*1i*freq).^repmat(s,size(freq,1),1),2);
    bvec_s = prod(diff.^repmat(s,lx,1),2) / prod(factorial(s));

    v = bvec_s .* param;
    v = lfft(freq,z,M,v,'transp');
    v = conj(dvec_s) .* v;

    valout = valout + v;
  end
   elseif strcmp(transp_flag,'notransp')
    valout = zeros(size(x,1),1);
  for is=1:size(s_array,1)
    s = s_array(is,:);
    dvec_s = prod((2*pi*1i*freq).^repmat(s,size(freq,1),1),2);
    bvec_s = prod(diff.^repmat(s,lx,1),2) / prod(factorial(s));

    v = dvec_s .* param;
    v = lfft(freq,z,M,v,'notransp');
    v = bvec_s .* v;

    valout = valout + v;
  end
  end
end
